/*
TASK:base
LANG:C++
*/

#include <stdio.h>
#include <vector>
using namespace std;
#define maxN 5000

vector <int> A[maxN+1];
bool F[maxN+1][maxN+1];
int N,M,Q[100001][2],Viz[maxN+1];

bool init();
void DFS(int vertex,int from);

int main()
{
 if (!init()) { printf("0\n");return 0; }
 int br,answ;
 for (br=1;br<=N;br++) DFS(br,br);
 for (br=1,answ=0;br<=M;br++)
    if (!F[Q[br][1]][Q[br][0]]) answ++;
 printf("%d\n",answ);
 return 0;
}

bool init()
{
// FILE *f=freopen("base.in","r",stdin);
 scanf("%d%d",&N,&M);
 if (N>maxN) return false;
 int i,x,y,rm=M;
 for (i=1;i<=M;i++) {
    scanf("%d%d",&x,&y);
    Q[i][0]=x;Q[i][1]=y;
    if (!F[x][y]) {
       A[x].push_back(y);
       F[x][y]=1; } else rm--; }
 if (N*rm>50000000) return false;
// fclose(f);
 return true;
}

void DFS(int vertex,int from)
{
 Viz[vertex]=from;
 F[from][vertex]=1;
 for (int i=0;i<A[vertex].size();i++)
    if (Viz[A[vertex][i]]!=from)
       DFS(A[vertex][i],from);
}
