/*
TASK: base
LANG: C
*/
#include <stdio.h>
#include <string.h>
#define MAXN 10002
#define MAXM 100002

 struct
  {
   long v1,v2;
  }z[MAXM];

 long marked[MAXN];
 long comp[MAXN];
 long n,m,c,o,res;
 long list[MAXN];
 long g[MAXM];
 long S[MAXN],E[MAXN];
 long d[MAXN];

 void dfs (long i)
  {
   long j;
   marked[i]=1;
   for (j=S[i];j<=E[i];j++)
    if (marked[g[j]]==0)
     dfs(g[j]);
   list[++o]=i;
  }

 void SCC (long i)
  {
   long j;
   comp[i]=c;
   for (j=S[i];j<=E[i];j++)
    if (comp[g[j]]==0)
     SCC(g[j]);
  }

 void make_graph ()
  {
   long i;
   memset(d,0,sizeof(d));
   for (i=1;i<=m;i++)
    d[z[i].v1]++;
   for (i=1;i<=n;i++)
    {
     S[i]=E[i-1]+1;
     E[i]=S[i]+d[i]-1;
     d[i]+=d[i-1];
    }
   for (i=1;i<=m;i++)
    g[d[z[i].v1]--]=z[i].v2;
  }

 int main ()
  {
   long i,j;
   scanf("%ld%ld",&n,&m);
   for (i=1;i<=m;i++)
    scanf("%ld%ld",&z[i].v1,&z[i].v2);
   make_graph();
   for (i=1;i<=n;i++)
    if (marked[i]==0)
     dfs(i);     
   for (i=1;i<=m;i++)
    {
     j=z[i].v1;
     z[i].v1=z[i].v2;
     z[i].v2=j;
    }
   make_graph();
   for (i=n;i>=1;i--)
    if (comp[list[i]]==0)
     {
      c++;
      SCC(list[i]);
     }
   for (i=1;i<=m;i++)
    if (comp[z[i].v1]!=comp[z[i].v2]) res++;
   printf("%ld\n",res);
   return 0;
  }
  
