/*
TASK:base
LANG:C++
*/
# include <stdio.h>
# include <stdlib.h>
# define MAXN 10005
# define MAXM 100006

//int _stklen = 1000000;

struct node{
    int y,next;
};

node data[MAXM],data1[MAXM];

int list[MAXM][2], num[MAXN], comp[MAXN], ind[MAXN];
int br[MAXN],br1[MAXN];

bool used[MAXN];

int n,m,fp=1,fp1=1,numlen=1,complen=1;

void readf() {
//    freopen("base.in","r",stdin);
    scanf("%d %d",&n,&m);
    for ( int i=0 ; i<m ; i++ ) {
	scanf("%d %d",&list[i][0],&list[i][1]);
	data[fp].y = list[i][1];
	data[fp].next = br[list[i][0]];
	br[list[i][0]] = fp++;

	data1[fp1].y = list[i][0];
	data1[fp1].next = br1[list[i][1]];
	br1[list[i][1]] = fp1++;
    }    
}

void dfs(int v) {
    used[v] = 1;
    int p = br[v];
    while (p) {
	if ( !used[data[p].y] ) {
	    dfs(data[p].y);
	}
	p = data[p].next;
    }
    num[v] = numlen++;
}

void dfs1(int v) {
    comp[v] = complen;
    int p = br1[v];
    while (p) {
	if ( !comp[data1[p].y] ) {
	    dfs1(data1[p].y);
	}
	p = data1[p].next;
    }
}

int cmp(const void *e1, const void *e2) {
    return num[*(int *)e2]-num[*(int *)e1];
}


void solve() {
    for ( int i=1 ; i<=n ; i++ ) {
	if ( !num[i] ) {
	    dfs(i);
	}
	ind[i] = i;
    }

    qsort(ind+1,n,sizeof(int),cmp);
    
    for ( int i=1 ; i<=n ; i++ ) {
	if ( !comp[ind[i]] ) {
	    dfs1(ind[i]);
	    complen++;
	}
    }
/*    for ( int i=1 ; i<=n ; i++ ) {
	printf("%d ",comp[i]);
    }
    printf("\n");*/
}

void writef() {
    int ans=0;
    for ( int i=0 ; i<m ; i++ )
	if ( comp[list[i][0]]!=comp[list[i][1]] ) 
	    ans++;
    printf("%d\n",ans);
}

int main() {
    readf();
    solve();
    writef();

    return 0;
}
