/*
TASK: mark
LANG: C++
*/

#include <cstdio>
#include <vector>
#include <algorithm>

typedef long long unsigned int ULONG;

void div(ULONG& a, ULONG& b)
{
	for (unsigned int i = 2; i < 100; i++)
		while (!(a%i) && !(b%i))
		{
			a /= i;
			b /= i;
		}
}

int main()
{
	ULONG a, b;
	unsigned int n, p, k;
	std::scanf("%u %u %u", &n, &p, &k);
	std::vector<unsigned int> m(k);
	for (unsigned int i = 0; i < k; i++)
		std::scanf("%u", &(m[i]));
	std::scanf("%llu %llu", &a, &b);

	std::sort(m.begin(), m.end());

	unsigned int answer = 0;
	for (unsigned int i = 1; i <= p && !answer; i++)
	{
		ULONG x = (n*a)/b;
		//std::printf("%llu/%llu %llu\n", a, b, (ULONG)(x+1));
		if (std::binary_search(m.begin(), m.end(), x+1))
			answer = i;

		a *= n;
		a -= x*b;
		a *= n;
		b *= n;
		div(a, b);
	}

	std::printf("%u\n", answer);

	return 0;
}
