/*
TASK: mark
LANG: C++
*/

#include <cstdio>
#include <cstdlib>
#include <cmath>

struct drob {
	unsigned long long a;
    unsigned long long b;
};

bool operator < (const drob &a, const drob &b) {
//	printf ("%lld/%lld <> %lld/%lld\n", a.a, a.b, b.a, b.b);
//	printf ("%d\n", (a.a*b.b < b.a*a.b));
	return (a.a*b.b < b.a*a.b);
}
drob& operator -= (drob &a, const int b) {
//    printf ("before -= : %lld %lld\n", a.a, a.b);

    a.a -= b * a.b;
//    printf ("after -= : %lld %lld\n", a.a, a.b);
    return a;
}

drob& operator *= (drob &a, int b) {
//	printf ("before *= : %lld %lld\n", a.a, a.b);
//	int sq = int(sqrt (b));

    int i;
    for (i = 2; i <= b; ++i)
    	while (a.b % i == 0 && b % i == 0) {
        	a.b /= i;
            b /= i;
        }
    a.a *= b;
//    printf ("after *= : %lld %lld\n", a.a, a.b);
    return a;
}

const int MAXN = 100;

int N, P, K;
drob D;
bool mark[MAXN];

int main () {
	scanf ("%d%d%d", &N, &P, &K);

    int i,j;
    int a;
    for (i = 0; i < K; ++i) {
    	scanf ("%d", &a);
        mark[--a] = 1;
    }


    scanf ("%lld%lld", &D.a, &D.b);


    if (D.a == D.b) {
    	printf ("0\n");
    	return 0;
    }

    drob tmp;
    
    for (j = 0; j < P; ++j) {
//        printf ("%lld %lld\n", D.a, D.b);

        tmp.a = 1;
    	tmp.b = N;

	    for (i = 1; i <= N; ++i)
    		if (D < tmp) {
            	--i;
//            	printf ("%d\n", i);
                if (mark[i]) {
                	printf ("%d\n", j+1);
                    return 0;
                } else
//                	printf ("not marked\n");
        		D *= N;
            	D -= i;
                break;
	        } else {
    	    	tmp.a++;
        	}
    }

    printf ("0\n");

	return 0;
}

