/*
TASK: monument
LANG: C
*/
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>

 typedef
  struct
   {
    double x,y;
   } point;

 point a[512],e;
 long n,er;
 double cur;
 double maxx,minx,maxy,miny;

 double orient (point a,point b,point c)
  {
   return a.x*(b.y-c.y)+a.y*(c.x-b.x)+b.x*c.y-c.x*b.y;
  }

 int main ()
  {
   long i,j,k;
   double g,p,q,o,pom;
   clock();
   scanf("%ld",&n);
   maxx=maxy=-1e6;
   minx=miny=1e6;
   for (i=1;i<=n;i++)
    {
     scanf("%lf%lf",&a[i].x,&a[i].y);
     if (maxx<a[i].x) maxx=a[i].x;
     if (minx>a[i].x) minx=a[i].x;
     
     if (maxy<a[i].y) maxy=a[i].y;
     if (miny>a[i].y) miny=a[i].y;
    }
   a[n+1]=a[1];
   cur=0;
   for (g=100,k=1;k<=6;k++,g/=10)
    {
     er=0;
// solve
     for (p=minx;p<=maxx;p+=g)
      for (q=miny;q<=maxy;q+=g)
       {
        if ((double)clock()/(double)CLOCKS_PER_SEC>0.9)
         {
          printf("%.3lf\n",cur);
          exit (0);
         }
        a[0].x=p;
        a[0].y=q;
        j=0;
        o=1e9;
        for (i=1;i<=n;i++)
         {
          pom=orient(a[0],a[i],a[i+1]);
          pom/=sqrt((a[i].y-a[i+1].y)*(a[i].y-a[i+1].y)+(a[i].x-a[i+1].x)*(a[i].x-a[i+1].x));
          pom=-pom;
          if (o>pom) o=pom;
          if (pom<=0) j=1;
         }
        if (j==0 && cur<o)
         {
          cur=o;
          e=a[0];
          er=1;
         }
       }
//
     if (minx<e.x-g && er==1) minx=e.x-g;
     if (maxx>e.x+g && er==1) maxx=e.x+g;
     if (miny<e.y-g && er==1) miny=e.y-g;
     if (maxy>e.y+g && er==1) maxy=e.y+g;
    }
   printf("%.3lf\n",cur);
   return 0;
  }

